<template lang="pug">
.card-parent(:tabindex="index+1")
  .card.card-corpus(
    ref="card"
    :class="{ 'card-focus': corpus.clonedFrom }"
    @mouseover="focused = true"
    @mouseout="focused = false"
  )
    .card-header
      nuxt-link.card-title.c-hand.mb-2(
        :to="{ path: localePath({ name: 'corpus-id', params: { id: corpus.pk } } ) }"
        :title="corpus.title"
      )
        v-clamp(autoresize :max-lines="2") {{ corpus.title }}
      .card-subtitle(v-if="corpus.authors")
        wbr
        span.teams.c-hand(
          v-if="affiliations.length > 0"
          :data-tippy-content="`${affiliations.length} ${$tc('organisation', affiliations.length)}`"
          v-tippy
        ).
          {{ affiliations.length }} #[z-icon(name="domain")] · 
        span.c-hand(
          v-if="corpus.authors && corpus.authors.length > 0"
          :data-tippy-content="`${corpus.authors.length} ${$tc('contributor', affiliations.length)}`"
          v-tippy
        ) {{ corpus.authors.length }} #[z-icon(name="person_outline")]
        span.ml-2(v-if="corpus.authors && corpus.authors.length > 0")
          avatar-chip(v-for="author in corpus.authors" :key="author.name" :text="author.name")
        span(v-else)
          | {{ $t('by') }}
          avatar-chip(:actor="corpus.actor")
    .card-body
      span.chip.c-hand(v-for="tag in filteredTags") {{ tag.name | capitalize }}
    .card-footer
      div
        tippy(v-if="corpus.versions" interactive trigger="mouseenter")
          span.card-versions(slot="content")
            div(v-for="version in corpus.versions")
              a {{ version }}
          nuxt-link.card-date.c-hand(
            :to="{ path: localePath({ name: 'corpus-id', params: { id: corpus.pk } } ) }"
            slot="trigger"
          )
            time(
              :datetime="new Date(corpus.originalPublicationAt || corpus.createdAt)"
              :title="new Date(corpus.originalPublicationAt || corpus.createdAt)"
            ) {{ $d(new Date(corpus.originalPublicationAt || corpus.createdAt), 'short') }}
            span(:title="new Date(corpus.updatedAt)")  · {{ $t('updated') | lowercase }} #[timeago(:datetime="corpus.updatedAt" :auto-update="20")]
        div(v-else)
          nuxt-link.card-date.c-hand(
            :to="{ path: localePath({ name: 'corpus-id', params: { id: corpus.pk } } ) }"
            slot="trigger"
          )
            time(
              :datetime="new Date(corpus.originalPublicationAt || corpus.createdAt)"
              :title="new Date(corpus.originalPublicationAt || corpus.createdAt)"
            ) {{ $d(new Date(corpus.originalPublicationAt || corpus.createdAt), 'short') }}
            span(:title="new Date(corpus.updatedAt)")  · {{ $t('updated') | lowercase }} #[timeago(:datetime="corpus.updatedAt" :auto-update="20")]
            span(v-if="corpus.isRemote" :title="corpus.actor.fullUsername")  · on {{ corpus.actor.fullUsername.split('@')[1] }}
      .ml-2
        nuxt-link.c-hand(
          :class="{ transparent: !focused }"
          :to="{ path: localePath({ name: 'corpus-id', params: { id: corpus.pk } } ) }"
        ) {{ corpus.commentsCount > 0 && corpus.commentsCount || '' }} #[z-icon(name="forum")]
  .card-addendum(v-if="corpus.description")
    .card.addendum-content(ref="addendum" :style="addendumLeft ? addendumLeftStyle : addendumStyle")
      p {{ corpus.description }}
</template>

<script>
import Vue from 'vue'
import VueTimeago from 'vue-timeago'
import VClamp from 'vue-clamp'

import AvatarChip from '~/components/AvatarChip'

Vue.use(VueTimeago, {
  name: 'Timeago'
})

export default {
  components: {
    VueTimeago,
    AvatarChip,
    VClamp
  },
  props: {
    corpus: {
      type: Object,
      default: () => {}
    },
    index: {
      type: Number,
      default: 1
    }
  },
  data() {
    return {
      id: null,
      focused: false,
      height: 0,
      width: 0,
      addendumLeft: false
    }
  },
  computed: {
    affiliations() {
      return this.corpus.authors
        ? [
            ...new Set(
              this.corpus.authors
                .map(author => author.affiliation)
                .filter(a => a !== '')
            )
          ].filter(a => a != null)
        : []
    },
    addendumStyle() {
      return {
        height: this.height + 2 + 'px',
        width: this.width + 'px',
        top: '-' + this.height - 2 + 'px'
      }
    },
    addendumLeftStyle() {
      return {
        ...this.addendumStyle,
        left: '-' + 2 * this.width + 'px'
      }
    },
    filteredTags() {
      /* 'Science' is a special tag for now
       * TODO: refactor once tags have types (intendedAudience tags, and regular tags)
       */
      return this.corpus.tags
        ? this.corpus.tags.filter(tag => tag.name !== 'Science')
        : []
    }
  },
  mounted() {
    this.id = this._uid
    this.$nextTick(function() {
      window.addEventListener('resize', this.getDimensions)
      this.getDimensions()
    })
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.getDimensions)
  },
  methods: {
    getDimensions() {
      this.$nextTick(() => {
        if (!this.$refs) return
        // update card dimensions
        this.height = this.$refs.card.clientHeight
        this.width = this.$refs.card.clientWidth

        // depending on position and dimensions, update position of the addendum
        this.addendumLeft = this.isElementLeftOfViewport(this.$refs.card)
      })
    },
    getPosition(element) {
      let xPosition = 0
      let yPosition = 0

      while (element) {
        /* eslint-disable */
        xPosition +=
          element.offsetLeft - element.scrollLeft + element.clientLeft
        yPosition += element.offsetTop - element.scrollTop + element.clientTop
        element = element.offsetParent
      }
      return {
        x: xPosition,
        y: yPosition
      }
    },
    isElementLeftOfViewport(reference) {
      const ww = Math.max(
        document.documentElement.clientWidth,
        window.innerWidth || 0
      ) // width of the window
      const pos = this.getPosition(reference) // position of the hovered element relative to window
      const ew = reference.offsetWidth

      if (pos.x > ww / 2) {
        // element is on right side of viewport
        return true
      }
      // element is on left side of viewport
      return false
    }
  }
}
</script>

<style lang="postcss" scoped>
.card-parent {
  outline: none;

  &:focus-visible {
    box-shadow: 0px 0px 4px rgba(var(--color-primary), 0.8);
  }
}
.card-corpus {
  text-align: left;
  flex-shrink: 1;

  .card-title {
    font-size: 1rem;
    overflow: hidden;
    display: block;
    color: rgb(var(--color-text)) !important;
    text-decoration: none;
    line-height: 1.1rem;
  }
  .card-subtitle {
    max-width: 100%;
    display: inline-block;
    overflow: hidden;
    white-space: nowrap;
    color: rgb(var(--color-text-light));
  }
  .card-body {
    padding-top: 0;
    max-height: 4rem;
    overflow: hidden;
  }
  .card-footer {
    padding-top: 0.4rem;
  }
  .card-body,
  .card-footer {
    color: rgb(var(--color-text-lighter));
    font-size: 0.6rem;

    .ml-2 a {
      color: rgba(var(--color-text-lighter), 0.7) !important;
    }
  }
  .card-date {
    color: rgb(var(--color-text-light)) !important;
    text-decoration: none;
  }
  .material-icons {
    font-size: 0.7rem;
    position: relative;
    top: 0.1rem;
  }
  .card-footer {
    display: flex;
    justify-content: space-between;

    .material-icons {
      top: 0.2rem;
      color: rgba(var(--color-text-lighter), 0.5);
    }
  }
  .transparent {
    opacity: 0;
  }
}
.card-versions {
  display: flex;
  flex-direction: column;
  text-align: left;
}
.card + .card-addendum {
  position: relative;
  left: 100%;
  opacity: 0;
  transition: opacity 0.3s;
  width: 0;
  height: 0;
  z-index: -1;

  .addendum-content {
    border-left: none;

    position: absolute;
    left: -1px;
    font-size: 0.6rem;
    padding: 0.5rem;

    text-align: left;
    text-overflow: ellipsis;
    overflow: hidden;

    background-color: rgba(var(--color-foreground));

    p {
      margin: 0;
      overflow: hidden;
    }
  }
}
.card:hover + .card-addendum {
  display: block;
  opacity: 1;
  z-index: 9;
}
.card-focus {
  /* left bar shown for local corpora */
  box-shadow: inset 0.3rem 0px 0px 0px rgba(var(--color-primary), 0.8);
}
</style>
